// Array to hold received data after conversion
int[] data = {0, 0, 0, 0};

// connection socket
Connection c;

// value to reach by millis() for next action
long nextTime = millis();

void setup() {
 // canvas size 
  size(400, 400);
  // make text big enough
  textSize(32);
  // create socket connection and in/output streams
  c = new Connection(
    new OnMessageReceived() {
      @Override
      // here the messages received from the socket end up
      public void messageReceived(String message) {
        // split received string into ints in data array
        data = int(split(trim(message), ','));
      }
    }
  );
}

void draw() {
  // check if it's time for action
  if (millis() > nextTime) {
    // setup next time for action
    nextTime = millis() + 200;
    // sollicit for sensor readings
    c.sendMessage("?");
    // see if anything is there, if so it's deliverd in the
    // messageReceived function defined above
    c.receiveMessage();
  }

  // show data on the canvas
  // first parameter determines background color
  background(color(data[0]*2, 0, 0));
  // display received parameter values
  text(data[0], 30, 30);
  text(data[1], 30, 60);
  text(data[2], 30, 90);
  text(data[3], 30, 120);
}

// called when app is terminated
// make sure to close socket connection
void exit() {
  c.stopConnection();
  super.exit();
}

